// This basic code was written for the IR Tank project, which can be found on www.3DProjectsForTomorrow.com © 2019 3D-PFT LLC 

#include <Servo.h>
#include <IRremote.h>

Servo leftservo; // create servo object to control a servo Motor 1 
Servo rightservo;// create servo object to control a servo Motor 2

int leftCenter = 90;
int rightCenter = 90;

int IRpin = 11;

IRrecv irINput(IRpin);
decode_results results;
IRsend sender;


void setup() {
  
leftservo.attach(3);  // attaches the servo on pin 3 
rightservo.attach(2); // attaches the servo on pin 2 
  
pinMode( A4 , OUTPUT); //LED 2
pinMode( A5 , OUTPUT); //LED 1

digitalWrite(A5 ,HIGH);// Turn on the Lights.
digitalWrite(A4 ,HIGH);// Turn on the Lights.
  

  Serial.begin(9600);
  irINput.enableIRIn();
  
  
 rightservo.write(rightCenter); // Stop the Tank from moving.
 leftservo.write(leftCenter); // Stop the Tank from moving.
  
}


int tankspeed = 45;// Max speed the tank will go. 


void loop() {
  

if (irINput.decode(&results)){
  long int Code = results.value;
  Serial.println(results.value);
  
  switch(results.value){
    case 16744575: //Go Forwards (Note: Put your Remote Decimal Number here.)
    forward(tankspeed);
    break;
    case 16748655: // Go Backwards(Note: Put your Remote Decimal Number here.)
    backward(tankspeed);
    break;
    case 16746615: // Turn Right(Note: Put your Remote Decimal Number here.)
    rightTurn(0,40);
    break;
    case 16750695: // Turn Left(Note: Put your Remote Decimal Number here.)
    leftTurn(0,40);
    break;
    case 16712445: //Stop(Note: Put your Remote Decimal Number here.)
    rightservo.write(rightCenter);  
    leftservo.write(leftCenter);
    break;
    

}
irINput.resume();
  
  
}

}


void forward(int servoSpeed ) {
  
    rightservo.write(rightCenter - (servoSpeed ));  
    leftservo.write(leftCenter +   (servoSpeed ));   
}

void backward(int servoSpeed ) {
  
    rightservo.write(rightCenter + (servoSpeed  ));  
    leftservo.write(leftCenter   -   (servoSpeed  ));   
    
}


void rightTurn(int servoSpeed, int turnSpeed) {
  
    rightservo.write(rightCenter + (servoSpeed  )    );  
    leftservo.write(leftCenter   + (servoSpeed  + turnSpeed)   );
}


void leftTurn(int servoSpeed, int turnSpeed) {
  
    rightservo.write(rightCenter - (servoSpeed   + turnSpeed ) );  
    leftservo.write(leftCenter   - (servoSpeed )   );
  
}







